import random
import subprocess
import json
import os

def polarity(train_prop=0.9, verbose=False):
  import subprocess
  base_path = 'data/rt-polarity/rt-polarity.{}.utf8'
  with open(base_path.format('pos')) as f:
    neg = [{'y':'pos', 'x':sent} for sent in f.readlines()]
  with open(base_path.format('neg')) as f:
    pos = [{'y':'neg', 'x':sent} for sent in f.readlines()]
    data = pos + neg

  random.seed(1)
  random.shuffle(data)
  train_size = int(train_prop * len(data))
  train_data,test_data = data[:train_size], data[train_size:]

  if verbose:
    print('loaded polarity: ', len(data))
    print('train {}, test {}'.format(len(train_data), len(test_data)))
    print(train_data[:3])
    return train_data,test_data

def amazon_reviews(train_prop=0.9, verbose=False):
  # current = os.path.abspath(os.path.dirname(__file__))
  path = 'data/amazon/Musical_Instruments_5.json'

  with open(path) as f:
    data = []
    for r in f.readlines():
      raw = eval(r)
      y = raw['overall']
      del raw['overall']
      data += [{'y': y, 'x': raw}]

  random.seed(1)
  random.shuffle(data)
  train_size = int(train_prop * len(data))
  train_data,test_data = data[:train_size], data[train_size:]

  if verbose:
      print('loaded reviews: ', len(data))
      print('train {}, test {}'.format(len(train_data), len(test_data)))
      print(json.dumps(train_data[:1], indent=2))
  return train_data,test_data
